// PS  ó
//  PS 2.0̻ 

string XFile = "plane.x";   // model
int    BCLR = 0xffffffff;   // background

// light direction (view space)
//float3 lightDir <  string UIDirectional = "Light Direction"; > = {0.577, -0.577, 0.577};


// texture
texture Tex0 < string name = "snow.jpg"; >;

// transformations
float4x4 World      : WORLD;
float4x4 View       : VIEW;
float4x4 Projection : PROJECTION;

struct VS_OUTPUT
{
    float4 Pos  : POSITION;
    float2 Tex  : TEXCOORD0;
};

VS_OUTPUT VS(
    float3 Pos  : POSITION, 
    float3 Norm : NORMAL, 
    float2 Tex  : TEXCOORD0)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;

    float4x4 WorldView = mul(World, View);

    float3 P = mul(float4(Pos, 1), (float4x3)WorldView);  // position (view space)
    Out.Pos  = mul(float4(P, 1), Projection);             // position (projected)
    Out.Tex  = Tex;

    return Out;
}

sampler Sampler = sampler_state
{
    Texture   = (Tex0);
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    AddressU = CLAMP;
    AddressV = CLAMP;
};

#define MAP_CX        256
#define MAP_CY        256
/*
float mask[9] = 
    { 0, 0, 0, 
      0, 1, 0, 
      0, 0, 0 };            // ⺻
      
float mask[9] = 
    { -1, 0, +1, 
      -2, 0, +2, 
      -1, 0, +1 };  // sobel
      
float mask[9] = 
    {  0, 0, -1, 
       0, 1,  0, 
       0, 0,  0 };  // Roberts
*/    
float mask[9] = 
    { -1, -1, -1, 
      -1,  8, -1, 
      -1, -1, -1 }; // Laplacian
       
float coord[3] = { -1, 0, +1 };
float divider = 1;

float4 PS_Simple( float2 Tex : TEXCOORD0 ) : COLOR
{
    float4 Color = 0;

    Color = tex2D( Sampler, Tex );
    return Color;
}

float4 PS_Mask( float2 Tex : TEXCOORD0 ) : COLOR
{
    float4 Color = 0;
    
    for( int i = 0 ; i < 9 ; i++ )
        Color += mask[i] * ( tex2D( Sampler, Tex + float2( coord[i%3]/MAP_CX, coord[i/3]/MAP_CY ) ) );
    
    return Color / divider;
}

technique TNoMask
{
    pass P0
    {
        // shaders
        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PS_Simple();
    }  
}

technique TYesMask
{
    pass P0
    {
        // shaders
        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PS_Mask();
    }  
}
